/* Example of read/write lincon i/o port.

   Author: Moki Matsushima

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

/* File level history (record changes for this file here.)

   v 0.0.0  1 Sep 2004 by Moki Matsushima
     create, blah blah... */

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include "msw.h"

int main()
{
	int fd,seg,addr;
	char *dev_file;
	slot_reg_t reg0, reg1, reg2;

	dev_file = "/dev/slot1";

	/* open device file */
	fd = open(dev_file, O_RDWR);
	if (fd < 0) {
		printf("Failure of open device file \"%s.\"\n", dev_file);
		return FAILURE;
	}

	/* setup I/O Selection Control Register
	   Port 0,1 as input port
	   Port 2 as output port */
	//reg0.id = IXPIO_PC;
	for (seg = 0; seg<=255 ; seg++){		
		reg0.offset = 0x40;
		reg0.value = seg;
		if (ioctl(fd, SLOT_WRITE_REG, &reg0) ) {
			printf("Failure of ioctl command SLOT_READ_REG SLOT_PC.\n");
			close(fd);
			return FAILURE;
		}
		for (addr=0x60;addr<=0x7f;addr++) {
			reg1.offset = addr;
			reg1.value = (seg+addr)&0xff;
			if (ioctl(fd, SLOT_WRITE_REG, &reg1) ) {
				printf("Failure of ioctl command SLOT_READ_REG SLOT_PC.\n");
				close(fd);
				return FAILURE;
			}
		}
	}
	

	for (seg = 0; seg<=255 ; seg++){		
		reg0.offset = 0x40;
		reg0.value = seg;
		if (ioctl(fd, SLOT_WRITE_REG, &reg0) ) {
			printf("Failure of ioctl command SLOT_READ_REG SLOT_PC.\n");
			close(fd);
			return FAILURE;
		}
		printf("\nsegment %d of ram ...\n",seg);
		for (addr=0x60;addr<=0x7f;addr++) {
			reg1.offset = addr;
			//reg1.value = 0x66;
			if (ioctl(fd, SLOT_READ_REG, &reg1) ) {
				printf("Failure of ioctl command SLOT_READ_REG SLOT_PC.\n");
				close(fd);
				return FAILURE;
			}
		printf("%x",reg1.value);
		}
	}

	printf("\nReadback from ram end ...\n");
	
	//printf("Module ID = %d \n",reg1.value);
	/* read, get out if error or ESC pressed */
	/*while (getchar() != 27) {
		if (ioctl(fd, SLOT_READ_REG, &reg1) ) {
			printf("Failure of ioctl command SLOT_READ_REG SLOT_PC.\n");
			close(fd);
			return FAILURE;
		}
		reg1.offset++;
	}
	if (ioctl(fd, SLOT_WRITE_REG, &reg0)) {
		printf("Failure of ioctl command SLOT_WRITE_REG SLOT_PC.\n");
		close(fd);
		return FAILURE;
	}*/
	puts("End of program");

	close(fd);
	return SUCCESS;
}
